#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Vertex.h"
/**
*allocation mmoire pour la structure Circuit
*/
GestionNoeuds* allocationGestionNoeuds(void)
{
     GestionNoeuds *pGestionNoeuds;
     pGestionNoeuds = malloc(sizeof *pGestionNoeuds);

      return pGestionNoeuds;
}
/**
*Fonction pour chargement des donnees sur les noeuds
*/
void creationGestionNoeuds(GestionNoeuds *pGestionNoeuds)
{
      /* Variable de parcours */
      int i, j;
     /* Ensuite, on va  commencer
     a remplir les vertex_t */
     FILE *fp = NULL;
     if ((fp = fopen("donnees.txt","r")) == NULL)
     {
          printf("Impossible d'ouvrir fichier donnees .txt \n");
          exit (-1);
      }
     else
     {
          for(i=0;i<nbreNoeuds ;i++)
          {

               fscanf(fp,"%d %lf %lf %d %d %d %d ",&(pGestionNoeuds -> tableau[i].no), &(pGestionNoeuds -> tableau[i].x), &(pGestionNoeuds -> tableau[i].y),  &(pGestionNoeuds -> tableau[i].demand),  &(pGestionNoeuds -> tableau[i].serviceTime),  &(pGestionNoeuds-> tableau[i].lower),  &(pGestionNoeuds -> tableau[i].upper));

          }
      }


}
/**
*Fonction afficher les  informations sur les noeuds
*/
void affichagevertex(GestionNoeuds *pGestionNoeuds)
{
     int i;
     for(i=0;i<nbreNoeuds;i++)
     {
          printf("\n%lf\n", pGestionNoeuds->tableau[i].y);
     }

}

/**
*Fonction permet calculer la distance entre tous les noeuds
* et de la stocker dans une matrice
*/


double **calculDistance(GestionNoeuds *pGestionNoeuds)
 {
      int i;
      int j;

      if ((pGestionNoeuds -> distanceEntreVertices = (double **) malloc (nbreNoeuds *sizeof(double*))) == NULL)
      {
            printf("Erreur lors du malloc sur pGestionNoeuds->distanceEntreVertices dans la fonction creationGestionNoeuds");
            exit (EXIT_FAILURE);

      }

      for (i=0 ; i< nbreNoeuds; i++)
      {
            if ((pGestionNoeuds -> distanceEntreVertices[i] = (double *) malloc (nbreNoeuds* sizeof(double))) == NULL)
            {
                  printf("Erreur lors du malloc de la deuxieme dimension du distanceEntreVertices dans la fonction creationGestionNoeuds");
                  exit (EXIT_FAILURE);
            }
            /* Cette case ne devrait jamais etre lu, mais par precaution */
            pGestionNoeuds -> distanceEntreVertices[i][i] = 0.0;

            for (j=0 ; j<i ; j++)
            {
                  pGestionNoeuds -> distanceEntreVertices[i][j] = pGestionNoeuds -> distanceEntreVertices[j][i] = sqrt(pow((pGestionNoeuds -> tableau[i].x - pGestionNoeuds -> tableau[j].x),2.0) + pow((pGestionNoeuds -> tableau[i].y - pGestionNoeuds -> tableau[j].y),2.0));

            }
      }
      return pGestionNoeuds -> distanceEntreVertices;
}
/**
*Fonction pour afficher la matrice  distance entre les Noeuds
*/

void affichageDistanceEntreNoeuds( GestionNoeuds *pGestionNoeuds)
{
      int i, j;

      for(i=0;i<nbreNoeuds;i++)
      {
            for(j=0;j<nbreNoeuds;j++)
            {
               printf("distance[%d][%d]= %lf\n",i,j,pGestionNoeuds->distanceEntreVertices[i][j]);

            }

      }
}
/**
*Fonction permet de sauvegarder du distancier dans un fichier sortie "distance.txt"
*/
void sauvegardeMatrcieDistances(double **distanceEntreNoeuds)
{
     int i,j;
     FILE *fp = NULL;
    fp = fopen("distance.txt","w") ;

     for(i=0;i<nbreNoeuds;i++)
     {
          for(j=0;j<nbreNoeuds;j++)
          {
              fprintf (fp, "%lf\n ", (distanceEntreNoeuds[i][j]));

          }
          printf("\n");
     }
     fclose(fp);
}
/**
*Fonction pour detruire la matrice aprs la fin de son  utilisation
*/
void freeTableau2D(double **distanceEntreNoeuds)
{
      free(distanceEntreNoeuds[0]);
      free(distanceEntreNoeuds);
}

