#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#define capaciteMax 12
#include "Vertex.h"
#include "Circuit.h"
#define TRACE 1
/* 1=trace
  0=pas de trace */
/**
*allocation dynamique de la structure Circuit
*/

Circuit *allocationCircuit(void)
{
     Circuit *pCircuit;
      pCircuit = malloc(sizeof *pCircuit);

      return pCircuit;
}

/**
*Cette fonction permet de chercher le noeud qui a la plus grosse demande
*/

int chercherIndiceNoeudPlusGrosseDemande(GestionNoeuds *pGestionNoeuds)
{
     int  demandMax = pGestionNoeuds->tableau[0].demand;
     int indiceNoeud = 0;
     int i;
     for(i=1; i<nbreNoeuds;i++)
     {
          if(demandMax < (pGestionNoeuds->tableau[i].demand))
          {
              demandMax= pGestionNoeuds->tableau[i].demand;
               indiceNoeud = i;
          }
     }

     return indiceNoeud;
}
/**
*Cette fonction permet de chercher le noeud le plus proche
*/
int chercherNoeudPlusProche(int nbreNoeudsTrouve, double **distanceEntreVertices,  GestionNoeuds *pGestionNoeuds, Circuit *pCircuit, int noeudDebut)
{
    int i,j;
    int trouve;
    int noeudProche = 0;
    int charge;
    int capaciteRestante ;


    double distanceMin =1000;

    for(i=0;i<nbreNoeuds;i++)
    {


        trouve =0;//trouve est faux


        if(i != noeudDebut && distanceEntreVertices[noeudDebut][i] < distanceMin)
        {

            j=0;


            while(j<=nbreNoeudsTrouve && trouve == 0)
            {


                    if(i==pCircuit->tableau[j])
                     {
                          trouve = 1;
                     }

                     j++;

            }
          charge+=pGestionNoeuds->tableau[i].demand;
          capaciteRestante-= pGestionNoeuds->tableau[i].demand;

            if(trouve==0&&pGestionNoeuds->tableau[i].demand<=0&&charge >=0)
            {

                              noeudProche = i;



               }
               if(trouve==0&&pGestionNoeuds->tableau[i].demand>=0&&capaciteRestante >=0)
               {



                             noeudProche = i;




               }

          }
     }

     return noeudProche;
}

/**
Fonction qui permet de creer la circuit du camion
**/
//algorithme:
//met le noeud zero comme premier noeud  visiter dans Circuit->tableau[0]
//ensuite, chercher le noeud qui a la plus grosse demande et qu'on le met dans Circuit->tableau[1]
//Aprs, On recherche le noeud le plus proche que l'on ajoute dans Circuit->tableau[2].
//On recherche le noeud le plus proche du noeud precedent. Si le noeud est dj dans la liste des noeuds visits, on prend le deuxime noeude plus proche,ainsi de suite.
Circuit* creationCircuit(int noeudDepart, GestionNoeuds *pGestionNoeuds )
{
     int i;
     int j;
     Circuit *pCircuit;
     pCircuit= allocationCircuit();

    /* Ici, on va constituer une solution. */

    /* On initialise */
     for (i=0 ; i<nbreNoeuds ; i++)
        pCircuit->tableau[i] =-1;

     int temp;
     int deuxiemeNoeud;

     double **distanceEntreNoeuds = calculDistance(pGestionNoeuds);
#if TRACE
     pCircuit->tableau[0] = 0;
#endif
#if TRACE
     deuxiemeNoeud = chercherIndiceNoeudPlusGrosseDemande(pGestionNoeuds);


#endif
#if TRACE
     pCircuit->tableau[1] = deuxiemeNoeud;

#endif
#if TRACE
     for(j=2;j<nbreNoeuds;j++)
     {

               temp = chercherNoeudPlusProche(6,  distanceEntreNoeuds, pGestionNoeuds, pCircuit,   pCircuit-> tableau[j-1]);

               //insrer l'lement dans le tableau
               pCircuit->tableau[j]=  temp;
               printf("  pCircuit->tableau[%d]:%d",  j, pCircuit->tableau[j]);


     }

     #endif

     return pCircuit;

}

/**
Fonction qui permet d'afficher la  circuit du camion
**/
void affichageCircuit(Circuit *pCircuit)
{
     int i;
     for(i=0;i<nbreNoeuds;i++)
     {
          printf("pCircuit->tableau [%d]: %d\n", i, pCircuit->tableau[i]);

     }

}
