/*****************************************************************************************
* Problme:
* Creation d'une tournee respectant les contraintes
* soit la tournee est cree en cherchant a chaque fois la ville la plus proche
* soit on peut creer la tournee de maniere aleatoire
* dans ce programme on cree la tournee selon  l'algorithme de plus proche voisin
*****************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "Vertex.h"
#include "Circuit.h"

int main(int argc, char *argv[])
{
     srand (time (NULL));
     int i;


     GestionNoeuds *pGestionNoeuds;
     pGestionNoeuds = allocationGestionNoeuds();
     Circuit *pCircuit;
     pCircuit = allocationCircuit();

     int noeudDepart = 0;
     creationGestionNoeuds (pGestionNoeuds);

     double **distanceEntreNoeuds = calculDistance(pGestionNoeuds);
     affichageDistanceEntreNoeuds(pGestionNoeuds);
     clock_t start = clock ();
     creationCircuit(noeudDepart, pGestionNoeuds );
     clock_t stop = clock();
     clock_t nb_ticks = stop - start;
     double dureeSec = (double) nb_ticks / CLOCKS_PER_SEC;
     printf ("time : %f secondes\n", dureeSec);
     printf("\ncircuit du camion: \n\n");
      affichageCircuit(pCircuit);




     freeTableau2D(distanceEntreNoeuds);

     getchar();

	return 0;
}
